import { Worker as JestWorker } from 'next/dist/compiled/jest-worker';
import '../lib/polyfill-promise-with-resolvers';
type FarmOptions = ConstructorParameters<typeof JestWorker>[1];
type Options<T extends object = object, Args extends any[] = any[]> = FarmOptions & {
    timeout?: number;
    onRestart?: (method: string, args: Args, attempts: number) => void;
    exposedMethods: ReadonlyArray<keyof T>;
    enableWorkerThreads?: boolean;
};
export declare class Worker<T extends object = object, Args extends any[] = any[]> {
    private _worker?;
    /**
     * Creates a new worker with the correct typings associated with the selected
     * methods.
     */
    static create<T extends object, Args extends any[] = any[]>(workerPath: string, options: Options<T, Args>): Worker<T, Args> & T;
    constructor(workerPath: string, options: Options<T, Args>);
    end(): ReturnType<JestWorker['end']>;
    /**
     * Quietly end the worker if it exists
     */
    close(): void;
}
export {};
